--- a/benchtests/bench-strtod.c
+++ b/benchtests/bench-strtod.c
@@ -114,7 +114,4 @@ do_bench (void)
 
 #define TEST_FUNCTION do_bench ()
 
-/* On slower platforms this test needs more than the default 2 seconds.  */
-#define TIMEOUT 10
-
 #include "../test-skeleton.c"
--- a/crypt/badsalttest.c
+++ b/crypt/badsalttest.c
@@ -81,6 +81,5 @@ do_test (void)
   return result;
 }
 
-#define TIMEOUT 5
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/crypt/sha256c-test.c
+++ b/crypt/sha256c-test.c
@@ -57,6 +57,5 @@ do_test (void)
   return result;
 }
 
-#define TIMEOUT 6
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/dirent/tst-fdopendir.c
+++ b/dirent/tst-fdopendir.c
@@ -122,6 +122,5 @@ do_test (void)
   return 0;
 }
 
-#define TIMEOUT 6
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/elf/tst-tls13.c
+++ b/elf/tst-tls13.c
@@ -26,5 +26,4 @@ do_test (void)
 }
 
 #define TEST_FUNCTION do_test ()
-#define TIMEOUT 3
 #include "../test-skeleton.c"
--- a/iconvdata/tst-loading.c
+++ b/iconvdata/tst-loading.c
@@ -181,6 +181,5 @@ do_test (void)
   return result;
 }
 
-#define TIMEOUT 10
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/io/test-lfs.c
+++ b/io/test-lfs.c
@@ -33,9 +33,6 @@ extern int do_test (int argc, char *argv[]);
 /* We have a preparation function.  */
 #define PREPARE do_prepare
 
-/* We might need a bit longer timeout.  */
-#define TIMEOUT 20 /* sec */
-
 /* This defines the `main' function and some more.  */
 #include <test-skeleton.c>
 
--- a/libio/tst-atime.c
+++ b/libio/tst-atime.c
@@ -10,7 +10,6 @@
 
 static int do_test (void);
 #define TEST_FUNCTION do_test ()
-#define TIMEOUT 5
 #include <test-skeleton.c>
 
 
--- a/localedata/tst-leaks.c
+++ b/localedata/tst-leaks.c
@@ -17,6 +17,5 @@ do_test (void)
   return 0;
 }
 
-#define TIMEOUT 5
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/malloc/tst-malloc-thread-fail.c
+++ b/malloc/tst-malloc-thread-fail.c
@@ -435,8 +435,5 @@ do_test (void)
   return 0;
 }
 
-/* The repeated allocations take some time on slow machines.  */
-#define TIMEOUT 20
-
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/misc/tst-tsearch.c
+++ b/misc/tst-tsearch.c
@@ -351,6 +351,5 @@ do_test (void)
   return total_error;
 }
 
-#define TIMEOUT 10
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/nptl/tst-cancel19.c
+++ b/nptl/tst-cancel19.c
@@ -281,6 +281,5 @@ do_test (void)
   return ret;
 }
 
-#define TIMEOUT 20
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/nptl/tst-cancel22.c
+++ b/nptl/tst-cancel22.c
@@ -115,6 +115,5 @@ do_test (void)
   return 0;
 }
 
-#define TIMEOUT 5
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/nptl/tst-cancel24.cc
+++ b/nptl/tst-cancel24.cc
@@ -109,5 +109,4 @@ do_test ()
 }
 
 #define TEST_FUNCTION do_test ()
-#define TIMEOUT 3
 #include "../test-skeleton.c"
--- a/nptl/tst-cancel25.c
+++ b/nptl/tst-cancel25.c
@@ -169,5 +169,4 @@ do_test (void)
 }
 
 #define TEST_FUNCTION do_test ()
-#define TIMEOUT 4
 #include "../test-skeleton.c"
--- a/nptl/tst-cancel7.c
+++ b/nptl/tst-cancel7.c
@@ -206,5 +206,4 @@ do_cleanup (void)
 #define CLEANUP_HANDLER do_cleanup ()
 #define PREPARE(argc, argv) do_prepare (argc, argv)
 #define TEST_FUNCTION do_test ()
-#define TIMEOUT 5
 #include "../test-skeleton.c"
--- a/nptl/tst-cond-except.c
+++ b/nptl/tst-cond-except.c
@@ -106,5 +106,4 @@ out:
 }
 
 #define TEST_FUNCTION do_test ()
-#define TIMEOUT 5
 #include "../test-skeleton.c"
--- a/nptl/tst-cond11.c
+++ b/nptl/tst-cond11.c
@@ -199,6 +199,5 @@ do_test (void)
 #endif
 }
 
-#define TIMEOUT 3
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/nptl/tst-cond14.c
+++ b/nptl/tst-cond14.c
@@ -113,5 +113,4 @@ do_test (void)
 
 
 #define TEST_FUNCTION do_test ()
-#define TIMEOUT 3
 #include "../test-skeleton.c"
--- a/nptl/tst-cond15.c
+++ b/nptl/tst-cond15.c
@@ -155,5 +155,4 @@ do_test (void)
 
 
 #define TEST_FUNCTION do_test ()
-#define TIMEOUT 6
 #include "../test-skeleton.c"
--- a/nptl/tst-cond24.c
+++ b/nptl/tst-cond24.c
@@ -244,6 +244,5 @@ do_test (void)
   return do_test_wait (thread_fun_timed);
 }
 
-#define TIMEOUT 20
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/nptl/tst-cond25.c
+++ b/nptl/tst-cond25.c
@@ -285,5 +285,4 @@ do_test (int argc, char **argv)
   return do_test_wait (timed_waiter);
 }
 
-#define TIMEOUT 5
 #include "../test-skeleton.c"
--- a/nptl/tst-eintr1.c
+++ b/nptl/tst-eintr1.c
@@ -99,6 +99,5 @@ do_test (void)
 }
 
 #define EXPECTED_SIGNAL SIGALRM
-#define TIMEOUT 3
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/nptl/tst-eintr2.c
+++ b/nptl/tst-eintr2.c
@@ -112,6 +112,5 @@ do_test (void)
 }
 
 #define EXPECTED_SIGNAL SIGALRM
-#define TIMEOUT 3
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/nptl/tst-eintr3.c
+++ b/nptl/tst-eintr3.c
@@ -66,6 +66,5 @@ do_test (void)
 }
 
 #define EXPECTED_SIGNAL SIGALRM
-#define TIMEOUT 1
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/nptl/tst-eintr4.c
+++ b/nptl/tst-eintr4.c
@@ -50,6 +50,5 @@ do_test (void)
 }
 
 #define EXPECTED_SIGNAL SIGALRM
-#define TIMEOUT 1
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/nptl/tst-eintr5.c
+++ b/nptl/tst-eintr5.c
@@ -75,6 +75,5 @@ do_test (void)
 }
 
 #define EXPECTED_SIGNAL SIGALRM
-#define TIMEOUT 3
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/nptl/tst-kill2.c
+++ b/nptl/tst-kill2.c
@@ -133,6 +133,5 @@ do_test (void)
 }
 
 
-#define TIMEOUT 5
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/nptl/tst-kill3.c
+++ b/nptl/tst-kill3.c
@@ -153,6 +153,5 @@ do_test (void)
 }
 
 
-#define TIMEOUT 5
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/nptl/tst-mutex4.c
+++ b/nptl/tst-mutex4.c
@@ -272,6 +272,5 @@ do_test (void)
   return 0;
 }
 
-#define TIMEOUT 4
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/nptl/tst-mutex5.c
+++ b/nptl/tst-mutex5.c
@@ -198,6 +198,5 @@ do_test (void)
   return 0;
 }
 
-#define TIMEOUT 4
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/nptl/tst-mutex9.c
+++ b/nptl/tst-mutex9.c
@@ -197,6 +197,5 @@ do_test (void)
   return 0;
 }
 
-#define TIMEOUT 3
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/nptl/tst-once2.c
+++ b/nptl/tst-once2.c
@@ -99,5 +99,4 @@ do_test (void)
 }
 
 #define TEST_FUNCTION do_test ()
-#define TIMEOUT 4
 #include "../test-skeleton.c"
--- a/nptl/tst-once3.c
+++ b/nptl/tst-once3.c
@@ -162,5 +162,4 @@ do_test (void)
 }
 
 #define TEST_FUNCTION do_test ()
-#define TIMEOUT 4
 #include "../test-skeleton.c"
--- a/nptl/tst-once4.c
+++ b/nptl/tst-once4.c
@@ -197,5 +197,4 @@ do_test (void)
 }
 
 #define TEST_FUNCTION do_test ()
-#define TIMEOUT 4
 #include "../test-skeleton.c"
--- a/nptl/tst-robust8.c
+++ b/nptl/tst-robust8.c
@@ -15,7 +15,6 @@ static void prepare (void);
 #define PREPARE(argc, argv) prepare ()
 static int do_test (void);
 #define TEST_FUNCTION do_test ()
-#define TIMEOUT 5
 #include "../test-skeleton.c"
 
 
--- a/nptl/tst-robust9.c
+++ b/nptl/tst-robust9.c
@@ -89,6 +89,5 @@ do_test (void)
   return 0;
 }
 
-#define TIMEOUT 5
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/nptl/tst-rwlock16.c
+++ b/nptl/tst-rwlock16.c
@@ -178,6 +178,5 @@ do_test (void)
 }
 
 
-#define TIMEOUT 3
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/nptl/tst-sem14.c
+++ b/nptl/tst-sem14.c
@@ -87,6 +87,5 @@ do_test (void)
   return thread_fail;
 }
 
-#define TIMEOUT 10
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/nptl/tst-sem6.c
+++ b/nptl/tst-sem6.c
@@ -75,6 +75,5 @@ do_test (void)
   return 0;
 }
 
-#define TIMEOUT 3
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/nptl/tst-signal3.c
+++ b/nptl/tst-signal3.c
@@ -256,7 +256,6 @@ do_test (void)
   return result;
 }
 
-# define TIMEOUT 10
 # define TEST_FUNCTION do_test ()
 
 #else
--- a/nptl/tst-spin4.c
+++ b/nptl/tst-spin4.c
@@ -104,6 +104,5 @@ do_test (void)
   return 0;
 }
 
-#define TIMEOUT 5
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/nptl/tst-tls3.c
+++ b/nptl/tst-tls3.c
@@ -201,6 +201,5 @@ do_test (void)
 }
 
 
-#define TIMEOUT 5
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/nptl/tst-tls4.c
+++ b/nptl/tst-tls4.c
@@ -177,6 +177,5 @@ do_test (void)
   return 0;
 }
 
-#define TIMEOUT 5
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/posix/tst-chmod.c
+++ b/posix/tst-chmod.c
@@ -370,8 +370,4 @@ do_test (int argc, char *argv[])
 }
 
 
-/* We need a few seconds since we have a few sleeps in the code.  */
-#define TIMEOUT	20
-
-
 #include "../test-skeleton.c"
--- a/posix/tst-getaddrinfo4.c
+++ b/posix/tst-getaddrinfo4.c
@@ -64,5 +64,4 @@ do_test (void)
 }
 
 #define TEST_FUNCTION do_test ()
-#define TIMEOUT 10
 #include "../test-skeleton.c"
--- a/posix/tst-getaddrinfo5.c
+++ b/posix/tst-getaddrinfo5.c
@@ -65,5 +65,4 @@ test (void)
 }
 
 #define TEST_FUNCTION test ()
-#define TIMEOUT 10
 #include "../test-skeleton.c"
--- a/posix/tst-preadwrite.c
+++ b/posix/tst-preadwrite.c
@@ -39,9 +39,6 @@ extern int do_test (int argc, char *argv[]);
 /* We have a preparation function.  */
 #define PREPARE do_prepare
 
-/* We might need a bit longer timeout.  */
-#define TIMEOUT 20 /* sec */
-
 /* This defines the `main' function and some more.  */
 #include <test-skeleton.c>
 
--- a/posix/tst-regex2.c
+++ b/posix/tst-regex2.c
@@ -244,6 +244,5 @@ do_test (void)
   return 0;
 }
 
-#define TIMEOUT 20
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/posix/tst-truncate.c
+++ b/posix/tst-truncate.c
@@ -40,9 +40,6 @@ extern int do_test (int argc, char *argv[]);
 /* We have a preparation function.  */
 #define PREPARE do_prepare
 
-/* We might need a bit longer timeout.  */
-#define TIMEOUT 20 /* sec */
-
 /* This defines the `main' function and some more.  */
 #include <test-skeleton.c>
 
--- a/posix/tst-waitid.c
+++ b/posix/tst-waitid.c
@@ -23,8 +23,6 @@
 #include <sys/wait.h>
 #include <signal.h>
 
-#define TIMEOUT 15
-
 static void
 test_child (void)
 {
--- a/rt/tst-aio.c
+++ b/rt/tst-aio.c
@@ -34,9 +34,6 @@ extern int do_test (int argc, char *argv[]);
 /* We have a preparation function.  */
 #define PREPARE do_prepare
 
-/* We might need a bit longer timeout.  */
-#define TIMEOUT 20 /* sec */
-
 /* This defines the `main' function and some more.  */
 #include <test-skeleton.c>
 
--- a/rt/tst-aio10.c
+++ b/rt/tst-aio10.c
@@ -115,5 +115,4 @@ do_test (void)
 }
 
 #define TEST_FUNCTION do_test ()
-#define TIMEOUT 5
 #include "../test-skeleton.c"
--- a/rt/tst-aio4.c
+++ b/rt/tst-aio4.c
@@ -23,9 +23,6 @@
 #include <unistd.h>
 #include <errno.h>
 
-/* We might need a bit longer timeout.  */
-#define TIMEOUT 10 /* sec */
-
 int my_signo;
 
 volatile sig_atomic_t flag;
--- a/rt/tst-aio5.c
+++ b/rt/tst-aio5.c
@@ -23,9 +23,6 @@
 #include <unistd.h>
 #include <errno.h>
 
-/* We might need a bit longer timeout.  */
-#define TIMEOUT 10 /* sec */
-
 #define MY_SIVAL 27
 
 volatile sig_atomic_t flag;
--- a/rt/tst-aio6.c
+++ b/rt/tst-aio6.c
@@ -23,10 +23,6 @@
 #include <sys/time.h>
 
 
-/* We expect to wait for 3 seconds so we have to increase the timeout.  */
-#define TIMEOUT 10 /* sec */
-
-
 #define TEST_FUNCTION do_test ()
 static int
 do_test (void)
--- a/rt/tst-aio64.c
+++ b/rt/tst-aio64.c
@@ -35,9 +35,6 @@ extern int do_test (int argc, char *argv[]);
 /* We have a preparation function.  */
 #define PREPARE do_prepare
 
-/* We might need a bit longer timeout.  */
-#define TIMEOUT 20 /* sec */
-
 /* This defines the `main' function and some more.  */
 #include <test-skeleton.c>
 
--- a/rt/tst-aio7.c
+++ b/rt/tst-aio7.c
@@ -24,11 +24,6 @@
 #include <stdlib.h>
 #include <unistd.h>
 
-
-/* We might wait for 3 seconds, so increase timeout to 10 seconds.  */
-#define TIMEOUT 10
-
-
 #define TEST_FUNCTION do_test ()
 static int
 do_test (void)
--- a/rt/tst-aio9.c
+++ b/rt/tst-aio9.c
@@ -120,5 +120,4 @@ do_test (void)
 }
 
 #define TEST_FUNCTION do_test ()
-#define TIMEOUT 5
 #include "../test-skeleton.c"
--- a/rt/tst-clock.c
+++ b/rt/tst-clock.c
@@ -22,13 +22,9 @@
 #include <time.h>
 #include <stdint.h>
 
-
 /* We want to see output immediately.  */
 #define STDOUT_UNBUFFERED
 
-/* We expect to run at least 10 seconds.  */
-#define TIMEOUT 15
-
 static int
 clock_test (clockid_t cl)
 {
--- a/rt/tst-cpuclock1.c
+++ b/rt/tst-cpuclock1.c
@@ -316,6 +316,5 @@ do_test (void)
 }
 
 
-#define TIMEOUT 5
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/rt/tst-cpuclock2.c
+++ b/rt/tst-cpuclock2.c
@@ -330,7 +330,6 @@ do_test (void)
 
   return result;
 }
-# define TIMEOUT 8
 # define TEST_FUNCTION do_test ()
 #endif
 
--- a/rt/tst-mqueue2.c
+++ b/rt/tst-mqueue2.c
@@ -35,7 +35,6 @@ alrm_handler (int sig)
 {
 }
 
-#define TIMEOUT 10
 #define TEST_FUNCTION do_test ()
 static int
 do_test (void)
--- a/rt/tst-mqueue4.c
+++ b/rt/tst-mqueue4.c
@@ -31,7 +31,6 @@
 #include <unistd.h>
 #include "tst-mqueue.h"
 
-#define TIMEOUT 4
 #define TEST_FUNCTION do_test ()
 static int
 do_test (void)
--- a/rt/tst-mqueue5.c
+++ b/rt/tst-mqueue5.c
@@ -33,8 +33,6 @@
 #include <unistd.h>
 #include "tst-mqueue.h"
 
-#define TIMEOUT 3
-
 #if _POSIX_THREADS && defined SIGRTMIN && defined SA_SIGINFO
 # include <pthread.h>
 
--- a/rt/tst-timer4.c
+++ b/rt/tst-timer4.c
@@ -178,7 +178,6 @@ check_ts (const char *name, const struct timespec *start,
     return 0;
 }
 
-#define TIMEOUT 15
 #define TEST_FUNCTION do_test ()
 static int
 do_test (void)
--- a/stdio-common/tst-fseek.c
+++ b/stdio-common/tst-fseek.c
@@ -477,6 +477,5 @@ do_test (void)
   return result;
 }
 
-#define TIMEOUT 3
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/stdio-common/tst-rndseek.c
+++ b/stdio-common/tst-rndseek.c
@@ -10,7 +10,6 @@ static char tempdata[65 * 1024];
 
 static int do_test (void);
 #define TEST_FUNCTION do_test ()
-#define TIMEOUT 10
 
 #include "../test-skeleton.c"
 
--- a/sysdeps/unix/sysv/linux/tst-skeleton-thread-affinity.c
+++ b/sysdeps/unix/sysv/linux/tst-skeleton-thread-affinity.c
@@ -32,10 +32,6 @@ static bool early_test (struct conf *);
 /* Arbitrary run time for each pass.  */
 #define PASS_TIMEOUT 2
 
-/* There are two passes (one with sched_yield, one without), and we
-   double the timeout to be on the safe side.  */
-#define TIMEOUT (2 * PASS_TIMEOUT * 2)
-
 #include "tst-skeleton-affinity.c"
 
 /* 0 if still running, 1 of stopping requested.  */
--- a/sysdeps/wordsize-64/tst-writev.c
+++ b/sysdeps/wordsize-64/tst-writev.c
@@ -108,8 +108,5 @@ do_test (void)
   return 0;
 }
 
-/* Time enough for a large writev syscall to complete.  */
-#define TIMEOUT 20
-
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/time/tst-ftime.c
+++ b/time/tst-ftime.c
@@ -54,6 +54,5 @@ do_test (void)
   return 0;
 }
 
-#define TIMEOUT 3
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"
--- a/timezone/tst-tzset.c
+++ b/timezone/tst-tzset.c
@@ -25,7 +25,6 @@
 #include <time.h>
 #include <unistd.h>
 
-#define TIMEOUT 5
 static int do_test (void);
 #define TEST_FUNCTION do_test ()
 #include "../test-skeleton.c"