diff --git a/benchtests/bench-strncmp.c b/benchtests/bench-strncmp.c
index 95a59c9465..065c7e7789 100644
--- a/benchtests/bench-strncmp.c
+++ b/benchtests/bench-strncmp.c
@@ -27,6 +27,7 @@
 
 #ifdef WIDE
 # define L(str) L##str
+# define STRDUP wcsdup
 # define SIMPLE_STRNCMP simple_wcsncmp
 
 /* Wcsncmp uses signed semantics for comparison, not unsigned.
@@ -48,6 +49,7 @@ simple_wcsncmp (const CHAR *s1, const CHAR *s2, size_t n)
 
 #else
 # define L(str) str
+# define STRDUP strdup
 # define SIMPLE_STRNCMP simple_strncmp
 
 /* Strncmp uses unsigned semantics for comparison.  */
@@ -190,6 +192,118 @@ do_test (json_ctx_t *json_ctx, size_t align1, size_t align2, size_t len, size_t
   json_element_object_end (json_ctx);
 }
 
+static void
+do_test_page_boundary_1 (json_ctx_t *json_ctx, CHAR *s1, CHAR *s2,
+			 size_t align1, size_t align2, size_t len,
+			 size_t n, int exp_result)
+{
+  json_element_object_begin (json_ctx);
+  json_attr_uint (json_ctx, "strlen", (double) len);
+  json_attr_uint (json_ctx, "len", (double) n);
+  json_attr_uint (json_ctx, "align1", (double) align1);
+  json_attr_uint (json_ctx, "align2", (double) align2);
+  json_array_begin (json_ctx, "timings");
+  FOR_EACH_IMPL (impl, 0)
+    do_one_test (json_ctx, impl, s1, s2, n, exp_result);
+  json_array_end (json_ctx);
+  json_element_object_end (json_ctx);
+}
+
+static void
+do_test_page_boundary (json_ctx_t *json_ctx)
+{
+  size_t size = 32 * 4;
+  size_t len;
+  CHAR *s1 = (CHAR *) (buf1 + (BUF1PAGES - 1) * page_size);
+  CHAR *s2 = (CHAR *) (buf2 + (BUF1PAGES - 1) * page_size);
+  int exp_result;
+
+  memset (s1, 'a', page_size);
+  memset (s2, 'a', page_size);
+
+  s1[(page_size / CHARBYTES) - 1] = (CHAR) 0;
+
+  for (size_t s = 99; s <= size; s++)
+    for (size_t s1a = 31; s1a < 32; s1a++)
+      for (size_t s2a = 30; s2a < 32; s2a++)
+	{
+	  size_t align1 = (page_size / CHARBYTES - s) - s1a;
+	  size_t align2 = (page_size / CHARBYTES - s) - s2a;
+	  CHAR *s1p = s1 + align1;
+	  CHAR *s2p = s2 + align2;
+	  len = (page_size / CHARBYTES) - 1 - align1;
+	  exp_result = SIMPLE_STRNCMP (s1p, s2p, s);
+	  do_test_page_boundary_1 (json_ctx, s1p, s2p, align1, align2,
+				   len, s, exp_result);
+	}
+}
+
+static void
+do_page_test (json_ctx_t *json_ctx, size_t offset1, size_t offset2,
+	      CHAR *s2)
+{
+  CHAR *s1;
+  int exp_result;
+
+  if (offset1 * CHARBYTES  >= page_size
+      || offset2 * CHARBYTES >= page_size)
+    return;
+
+  s1 = (CHAR *) buf1;
+  s1 += offset1;
+  s2 += offset2;
+
+  size_t len = (page_size / CHARBYTES) - offset1;
+
+  exp_result= *s1;
+
+  json_element_object_begin (json_ctx);
+  json_attr_uint (json_ctx, "strlen", (double) len);
+  json_attr_uint (json_ctx, "len", (double) page_size);
+  json_attr_uint (json_ctx, "align1", (double) offset1);
+  json_attr_uint (json_ctx, "align2", (double) offset2);
+  json_array_begin (json_ctx, "timings");
+  {
+    FOR_EACH_IMPL (impl, 0)
+      do_one_test (json_ctx, impl, s1, s2, page_size, -exp_result);
+  }
+  json_array_end (json_ctx);
+  json_element_object_end (json_ctx);
+
+  json_element_object_begin (json_ctx);
+  json_attr_uint (json_ctx, "strlen", (double) len);
+  json_attr_uint (json_ctx, "len", (double) page_size);
+  json_attr_uint (json_ctx, "align1", (double) offset1);
+  json_attr_uint (json_ctx, "align2", (double) offset2);
+  json_array_begin (json_ctx, "timings");
+  {
+    FOR_EACH_IMPL (impl, 0)
+      do_one_test (json_ctx, impl, s1, s2, page_size, exp_result);
+  }
+  json_array_end (json_ctx);
+  json_element_object_end (json_ctx);
+}
+
+static void
+do_test_page (json_ctx_t *json_ctx)
+{
+  size_t i;
+  CHAR *s1, *s2;
+
+  s1 = (CHAR *) buf1;
+  for (i = 0; i < (page_size / CHARBYTES) - 1; i++)
+    s1[i] = 23;
+  s1[i] = 0;
+
+  s2 = STRDUP (s1);
+
+  for (i = 0; i < 64; ++i)
+    do_page_test (json_ctx, (3988 / CHARBYTES) + i,
+		  (2636 / CHARBYTES), s2);
+
+  free (s2);
+}
+
 int
 test_main (void)
 {
@@ -267,6 +381,9 @@ test_main (void)
       do_test_limit (&json_ctx, 0, 0, 15 - i, 16 - i, 255, -1);
     }
 
+  do_test_page_boundary (&json_ctx);
+  do_test_page (&json_ctx);
+
   json_array_end (&json_ctx);
   json_attr_object_end (&json_ctx);
   json_attr_object_end (&json_ctx);