diff --git a/benchtests/bench-memcpy-large.c b/benchtests/bench-memcpy-large.c
index efb9627b1e..0021274e92 100644
--- a/benchtests/bench-memcpy-large.c
+++ b/benchtests/bench-memcpy-large.c
@@ -52,11 +52,12 @@ do_one_test (json_ctx_t *json_ctx, impl_t *impl, char *dst, const char *src,
 }
 
 static void
-do_test (json_ctx_t *json_ctx, size_t align1, size_t align2, size_t len)
+do_test (json_ctx_t *json_ctx, size_t align1, size_t align2, size_t len,
+         int both_ways)
 {
   size_t i, j;
   char *s1, *s2;
-
+  size_t repeats;
   align1 &= 4095;
   if (align1 + len >= page_size)
     return;
@@ -68,20 +69,27 @@ do_test (json_ctx_t *json_ctx, size_t align1, size_t align2, size_t len)
   s1 = (char *) (buf1 + align1);
   s2 = (char *) (buf2 + align2);
 
-  for (i = 0, j = 1; i < len; i++, j += 23)
-    s1[i] = j;
+  for (repeats = both_ways ? 2 : 1; repeats; --repeats)
+    {
+      for (i = 0, j = 1; i < len; i++, j += 23)
+        s1[i] = j;
 
-  json_element_object_begin (json_ctx);
-  json_attr_uint (json_ctx, "length", (double) len);
-  json_attr_uint (json_ctx, "align1", (double) align1);
-  json_attr_uint (json_ctx, "align2", (double) align2);
-  json_array_begin (json_ctx, "timings");
+      json_element_object_begin (json_ctx);
+      json_attr_uint (json_ctx, "length", (double) len);
+      json_attr_uint (json_ctx, "align1", (double) align1);
+      json_attr_uint (json_ctx, "align2", (double) align2);
+      json_attr_uint (json_ctx, "dst > src", (double) (s2 > s1));
+      json_array_begin (json_ctx, "timings");
 
-  FOR_EACH_IMPL (impl, 0)
-    do_one_test (json_ctx, impl, s2, s1, len);
+      FOR_EACH_IMPL (impl, 0)
+        do_one_test (json_ctx, impl, s2, s1, len);
 
-  json_array_end (json_ctx);
-  json_element_object_end (json_ctx);
+      json_array_end (json_ctx);
+      json_element_object_end (json_ctx);
+
+      s1 = (char *) (buf2 + align1);
+      s2 = (char *) (buf1 + align2);
+    }
 }
 
 int
@@ -109,14 +117,14 @@ test_main (void)
   json_array_begin (&json_ctx, "results");
   for (i = START_SIZE; i <= MIN_PAGE_SIZE; i <<= 1)
     {
-      do_test (&json_ctx, 0, 0, i + 7);
-      do_test (&json_ctx, 0, 3, i + 15);
-      do_test (&json_ctx, 3, 0, i + 31);
-      do_test (&json_ctx, 3, 5, i + 63);
-      do_test (&json_ctx, 0, 127, i);
-      do_test (&json_ctx, 0, 255, i);
-      do_test (&json_ctx, 0, 256, i);
-      do_test (&json_ctx, 0, 4064, i);
+      do_test (&json_ctx, 0, 0, i + 7, 1);
+      do_test (&json_ctx, 0, 3, i + 15, 1);
+      do_test (&json_ctx, 3, 0, i + 31, 1);
+      do_test (&json_ctx, 3, 5, i + 63, 1);
+      do_test (&json_ctx, 0, 127, i, 1);
+      do_test (&json_ctx, 0, 255, i, 1);
+      do_test (&json_ctx, 0, 256, i, 1);
+      do_test (&json_ctx, 0, 4064, i, 1);
     }
 
   json_array_end (&json_ctx);
diff --git a/benchtests/bench-memcpy-walk.c b/benchtests/bench-memcpy-walk.c
index b04d8ac0ed..610529ef1b 100644
--- a/benchtests/bench-memcpy-walk.c
+++ b/benchtests/bench-memcpy-walk.c
@@ -66,17 +66,30 @@ do_one_test (json_ctx_t *json_ctx, impl_t *impl, char *dst, char *src,
 }
 
 static void
-do_test (json_ctx_t *json_ctx, size_t len)
+do_test (json_ctx_t *json_ctx, size_t len, int both_ways)
 {
-  json_element_object_begin (json_ctx);
-  json_attr_uint (json_ctx, "length", (double) len);
-  json_array_begin (json_ctx, "timings");
 
-  FOR_EACH_IMPL (impl, 0)
-    do_one_test (json_ctx, impl, (char *) buf2, (char *) buf1, len);
+  char *s1, *s2;
+  size_t repeats;
+  s1 = (char *) (buf1);
+  s2 = (char *) (buf2);
+
+  for (repeats = both_ways ? 2 : 1; repeats; --repeats)
+    {
+      json_element_object_begin (json_ctx);
+      json_attr_uint (json_ctx, "length", (double) len);
+      json_attr_uint (json_ctx, "dst > src", (double) (s2 > s1));
+      json_array_begin (json_ctx, "timings");
 
-  json_array_end (json_ctx);
-  json_element_object_end (json_ctx);
+      FOR_EACH_IMPL (impl, 0)
+        do_one_test (json_ctx, impl, s2, s1, len);
+
+      json_array_end (json_ctx);
+      json_element_object_end (json_ctx);
+
+      s1 = (char *) (buf2);
+      s2 = (char *) (buf1);
+    }
 }
 
 int
@@ -103,8 +116,8 @@ test_main (void)
   json_array_begin (&json_ctx, "results");
   for (size_t i = START_SIZE; i <= MIN_PAGE_SIZE; i <<= 1)
     {
-      do_test (&json_ctx, i);
-      do_test (&json_ctx, i + 1);
+      do_test (&json_ctx, i, 1);
+      do_test (&json_ctx, i + 1, 1);
     }
 
   json_array_end (&json_ctx);
diff --git a/benchtests/bench-memcpy.c b/benchtests/bench-memcpy.c
index 184495d539..d9236a2282 100644
--- a/benchtests/bench-memcpy.c
+++ b/benchtests/bench-memcpy.c
@@ -54,11 +54,12 @@ do_one_test (json_ctx_t *json_ctx, impl_t *impl, char *dst, const char *src,
 }
 
 static void
-do_test (json_ctx_t *json_ctx, size_t align1, size_t align2, size_t len)
+do_test (json_ctx_t *json_ctx, size_t align1, size_t align2, size_t len,
+         int both_ways)
 {
   size_t i, j;
   char *s1, *s2;
-
+  size_t repeats;
   align1 &= 63;
   if (align1 + len >= page_size)
     return;
@@ -70,20 +71,27 @@ do_test (json_ctx_t *json_ctx, size_t align1, size_t align2, size_t len)
   s1 = (char *) (buf1 + align1);
   s2 = (char *) (buf2 + align2);
 
-  for (i = 0, j = 1; i < len; i++, j += 23)
-    s1[i] = j;
+  for (repeats = both_ways ? 2 : 1; repeats; --repeats)
+    {
+      for (i = 0, j = 1; i < len; i++, j += 23)
+        s1[i] = j;
 
-  json_element_object_begin (json_ctx);
-  json_attr_uint (json_ctx, "length", (double) len);
-  json_attr_uint (json_ctx, "align1", (double) align1);
-  json_attr_uint (json_ctx, "align2", (double) align2);
-  json_array_begin (json_ctx, "timings");
+      json_element_object_begin (json_ctx);
+      json_attr_uint (json_ctx, "length", (double) len);
+      json_attr_uint (json_ctx, "align1", (double) align1);
+      json_attr_uint (json_ctx, "align2", (double) align2);
+      json_attr_uint (json_ctx, "dst > src", (double) (s2 > s1));
+      json_array_begin (json_ctx, "timings");
 
-  FOR_EACH_IMPL (impl, 0)
-    do_one_test (json_ctx, impl, s2, s1, len);
+      FOR_EACH_IMPL (impl, 0)
+        do_one_test (json_ctx, impl, s2, s1, len);
 
-  json_array_end (json_ctx);
-  json_element_object_end (json_ctx);
+      json_array_end (json_ctx);
+      json_element_object_end (json_ctx);
+
+      s1 = (char *) (buf2 + align1);
+      s2 = (char *) (buf1 + align2);
+    }
 }
 
 int
@@ -111,46 +119,46 @@ test_main (void)
   json_array_begin (&json_ctx, "results");
   for (i = 0; i < 18; ++i)
     {
-      do_test (&json_ctx, 0, 0, 1 << i);
-      do_test (&json_ctx, i, 0, 1 << i);
-      do_test (&json_ctx, 0, i, 1 << i);
-      do_test (&json_ctx, i, i, 1 << i);
+      do_test (&json_ctx, 0, 0, 1 << i, 1);
+      do_test (&json_ctx, i, 0, 1 << i, 1);
+      do_test (&json_ctx, 0, i, 1 << i, 1);
+      do_test (&json_ctx, i, i, 1 << i, 1);
     }
 
   for (i = 0; i < 32; ++i)
     {
-      do_test (&json_ctx, 0, 0, i);
-      do_test (&json_ctx, i, 0, i);
-      do_test (&json_ctx, 0, i, i);
-      do_test (&json_ctx, i, i, i);
+      do_test (&json_ctx, 0, 0, i, 0);
+      do_test (&json_ctx, i, 0, i, 0);
+      do_test (&json_ctx, 0, i, i, 0);
+      do_test (&json_ctx, i, i, i, 0);
     }
 
   for (i = 3; i < 32; ++i)
     {
       if ((i & (i - 1)) == 0)
 	continue;
-      do_test (&json_ctx, 0, 0, 16 * i);
-      do_test (&json_ctx, i, 0, 16 * i);
-      do_test (&json_ctx, 0, i, 16 * i);
-      do_test (&json_ctx, i, i, 16 * i);
+      do_test (&json_ctx, 0, 0, 16 * i, 1);
+      do_test (&json_ctx, i, 0, 16 * i, 1);
+      do_test (&json_ctx, 0, i, 16 * i, 1);
+      do_test (&json_ctx, i, i, 16 * i, 1);
     }
 
   for (i = 32; i < 64; ++i)
     {
-      do_test (&json_ctx, 0, 0, 32 * i);
-      do_test (&json_ctx, i, 0, 32 * i);
-      do_test (&json_ctx, 0, i, 32 * i);
-      do_test (&json_ctx, i, i, 32 * i);
+      do_test (&json_ctx, 0, 0, 32 * i, 1);
+      do_test (&json_ctx, i, 0, 32 * i, 1);
+      do_test (&json_ctx, 0, i, 32 * i, 1);
+      do_test (&json_ctx, i, i, 32 * i, 1);
     }
 
-  do_test (&json_ctx, 0, 0, getpagesize ());
+  do_test (&json_ctx, 0, 0, getpagesize (), 1);
 
   for (i = 0; i <= 32; ++i)
     {
-      do_test (&json_ctx, 0, 0, 2048 + 64 * i);
-      do_test (&json_ctx, i, 0, 2048 + 64 * i);
-      do_test (&json_ctx, 0, i, 2048 + 64 * i);
-      do_test (&json_ctx, i, i, 2048 + 64 * i);
+      do_test (&json_ctx, 0, 0, 2048 + 64 * i, 1);
+      do_test (&json_ctx, i, 0, 2048 + 64 * i, 1);
+      do_test (&json_ctx, 0, i, 2048 + 64 * i, 1);
+      do_test (&json_ctx, i, i, 2048 + 64 * i, 1);
     }
 
   json_array_end (&json_ctx);